#include <algorithm>
#include <iostream>
#include <unordered_map>
#include <vector>

using namespace std;

int main() {
  int N;
  cin >> N;
  vector <int> A(N);
  for (int i = 0; i < N; i++) {
    cin >> A[i];
  }
  unordered_map<int, vector<int>> indeksy;
  for (int i=0; i<N; i++) {
    indeksy[A[i]].push_back(i);
  }

  int wynik = 1e9;
  for (auto [ignore, lista_indeksow] : indeksy) {
    for (int i=2; i < (int)lista_indeksow.size(); i++) {
      wynik = min(wynik, lista_indeksow[i] - lista_indeksow[i-2] + 1);
    }
  }
  if (wynik == 1e9) {
    cout << "NIE\n";
  } else {
    cout << wynik << "\n";
  }
}
